<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +------------------------------------------------------------------------+
// | git-php - PHP front end to git repositories                            |
// +------------------------------------------------------------------------+
// | Copyright (c) 2006 Zack Bartel                                         |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// |                                                                        |
// | Author: Peeter Vois http://people.proekspert.ee/peeter/blog            |
// +------------------------------------------------------------------------+

/* Path concatenation function by David Miller from
* http://stackoverflow.com/questions/1091107/how-to-join-filesystem-path-strings-in-php
*/
function unix_path() {
    $args = func_get_args();
    $paths = array();
    foreach($args as $arg) {
        $paths = array_merge($paths, (array)$arg);
    }
    foreach($paths as & $path) {
        $path = trim($path, '/');
    }
    if (substr($args[0], 0, 1) == '/') {
        $paths[0] = '/' . $paths[0];
    }
    return join('/', $paths);
}
function create_directory($fullpath, $mode) {
    if (($fullpath[0] != '/') && ($fullpath[1] == 0)) {
        echo "Wrong path name $fullpath\n";
        die();
    }
    if (!is_dir($fullpath)) {
        if (!mkdir($fullpath)) {
            echo "Error making directory $fullpath\n";
            die();
        }
        chmod($fullpath, $mode);
        return true;
    }
    error_reporting(0);
    chmod($fullpath, $mode);
    error_reporting(1);
    return $fullpath;
}
function create_project_directory($dir_name, $proj) {
    global $data_directory, $data_dir_mode;
    create_directory(unix_path($data_directory, $dir_name), $data_dir_mode);
    return create_directory(unix_path($data_directory, $dir_name, $proj), $data_dir_mode);
}
function create_cache_directory($proj) {
    global $cache_name;
    return create_project_directory($cache_name, $proj);
}
function create_bundles_directory($proj) {
    global $bundle_name;
    return create_project_directory($bundle_name, $proj);
}
?>
